export declare type PoolCallback<T> = (item: T) => void;
export interface PoolOptions<T, O = any> {
    options?: O;
    initializer?: PoolCallback<T> | null;
    cleaner?: PoolCallback<T> | null;
}
export declare class Pool<T, O = any> implements Required<PoolOptions<T, O>> {
    readonly factory: new (options?: O) => T;
    constructor(factory: new (options?: O) => T, options?: PoolOptions<T, O>);
    options: O;
    initializer: PoolCallback<T> | null;
    cleaner: PoolCallback<T> | null;
    private _items;
    get size(): number;
    set size(value: number);
    get(): T;
    add(item: T): this;
}
